import ea.*; //Importieren der gesamten Engine Alpha

public class Hauptspiel
extends Game
implements KlickReagierbar, TastenGedruecktReagierbar
{
    private Maus maus;
    private int spielezähler;
    boolean ende_erreicht;
    private SPIELFELD feld_aktuell;

    public Hauptspiel()
    {
        super(600,600);
        super.tastenGedruecktReagierbarAnmelden(this);
        feld_aktuell = new SPIELFELD();
        spielezähler = 0;
        ende_erreicht = false;
        Bild mausbild = new Bild(0,0,"mauszeiger2.gif");
        Punkt hotspot = new Punkt(-25,-25);
        maus = new Maus(mausbild, hotspot, false, false);
        mausAnmelden(maus);
        Bild Hintergrund = new Bild(0,0,"Hintergrund.jpg");
        sichtbarMachen(Hintergrund);
        maus.klickReagierbarAnmelden(this);
    }

    public void tasteGedrueckt(int tastenCode)
    {
    }

    public void tasteReagieren(int tastenCode) 
    {
        if (tastenCode == 1)
        {
            System.exit(0);
        }
    }
    
    public void sichtbarMachen(Raum a)
    {
        wurzel.add(a);
    }

    public void klickReagieren(int x, int y) 
    {
        int reihe, spalte, feldnummer;
        spalte = x / 200;
        reihe = y / 200;
        feldnummer = spalte + reihe*3;
        if(spielezähler%2==0 && !ende_erreicht)
        {
           if (feld_aktuell.gibFeld(feldnummer)==0)
           {
               sichtbarMachen(new Bild(75+spalte*200,75+reihe*200,"Kreis.gif"));
               feld_aktuell.feldBelegen(feldnummer,-1);
               spielezähler++;
               // berechne nun Antwort des PC
               if (feld_aktuell.gibFreieFelder()>0)
               {
                   feldnummer = feld_aktuell.merken_maxzug();
                   reihe = feldnummer/3;
                   spalte = feldnummer%3;
                   sichtbarMachen(new Bild(75+spalte*200,75+reihe*200,"X.gif"));
                   feld_aktuell.feldBelegen(feldnummer,1);
                   spielezähler++;
               }
           }
        }
        if(feld_aktuell.kreis_gewinnt())
        {
            ende_erreicht = true;
            sichtbarMachen(new Text(75,225,"DAS SPIEL IST BEENDET! KREIS GEWINNT!"));
            sichtbarMachen(new Text(81,295,"ZUM BEENDEN BITTE TASTE 'B' DRÜCKEN!"));
        }
        if(feld_aktuell.kreuz_gewinnt())
        {
            ende_erreicht = true;
            sichtbarMachen(new Text(75,225,"DAS SPIEL IST BEENDET! KREUZ GEWINNT!"));
            sichtbarMachen(new Text(81,295,"ZUM BEENDEN BITTE TASTE 'B' DRÜCKEN!"));
        }
        if(!feld_aktuell.kreis_gewinnt() && !feld_aktuell.kreuz_gewinnt() && spielezähler==9)
        {
            ende_erreicht = true;
            sichtbarMachen(new Text(75,225,"DAS SPIEL IST BEENDET! UNENTSCHIEDEN!"));
            sichtbarMachen(new Text(81,295,"ZUM BEENDEN BITTE TASTE 'B' DRÜCKEN!"));
        }
    }
}